
; VCF-MW 12 6502 Badge Software
; Hardware design by Lee Hart
; Software design by Daryl Rictor
;
; This software is free to use and modify in any non-commercial application.
; Comericial use is prohibited without expressed, written permission from the author.
;
;****************************************************************************
; Reset, Interrupt, & Break Handlers
;****************************************************************************

;--------------Reset handler----------------------------------------------
Reset          SEI                     ; diable interupts
               CLD                     ; clear decimal mode                      
               LDX   #$FF              ;
               TXS                     ; init stack pointer
               jsr   Serial_Init       ; init serial port
               jsr   LED_Init          ; init LED driver	
	       lda   #$00              ; Clear registers
               TAY                     ;
               TAX                     ;
               CLC                     ; clear flags
               CLD                     ; clear decimal mode
               CLI                     ; enable IRQ's
               JMP  MonitorBoot        ; Monitor for cold reset                       
NMIjump	       RTI                     ; NMI null routine	
Interrupt      PHA                     ; save A
               PHX                     ; save X
               TSX                     ; get stack pointer
               LDA   $0103,X           ; load INT-P Reg off stack
               AND   #$10              ; mask BRK
               bne   Reset             ; BRK, do Reset code
               plx                     ; restore x 
               jmp   IRQ               ; do IRQ code

;
;  NMIjmp      =     $FFFA             
;  RESjmp      =     $FFFC             
;  INTjmp      =     $FFFE             

               *=    $FFFA
               .word  NMIjump          ; NMI jump vector
               .word  Reset            ; RES jump vector
               .word  Interrupt        ; IRQ jump vector
;end of file
